Index: /trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj	(revision 2457)
+++ /trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj	(revision 2458)
@@ -78,6 +78,10 @@
     <Reference Include="System.Data" />
     <Reference Include="System.Xml" />
+    <Reference Include="WindowsBase">
+      <RequiredTargetFramework>3.0</RequiredTargetFramework>
+    </Reference>
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="ObservableList.cs" />
     <Compile Include="DoubleExtensions.cs">
       <SubType>Code</SubType>
Index: /trunk/sources/HeuristicLab.Common/3.2/ObservableCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Common/3.2/ObservableCollection.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.Common/3.2/ObservableCollection.cs	(revision 2458)
@@ -23,8 +23,9 @@
 using System.Linq;
 using System.Text;
+using System.Collections.Specialized;
 
 namespace HeuristicLab.Common {
-  public class ObservableCollection<T> : ICollection<T> {
-    private List<T> list;
+  public class ObservableCollection<T> : ICollection<T>, INotifyCollectionChanged {
+    protected List<T> list;
 
     public ObservableCollection() {
@@ -33,29 +34,25 @@
 
     #region Events
-    public event EventHandler CollectionCleared;
-    protected void FireCollectionCleared() {
-      OnCollectionCleared();
-    } 
-    protected virtual void OnCollectionCleared() {
-      if (CollectionCleared != null)
-        CollectionCleared(this, new EventArgs());
+    public event NotifyCollectionChangedEventHandler CollectionChanged;
+
+    protected void FireCollectionChanged(NotifyCollectionChangedEventArgs e) {
+      if (CollectionChanged != null) {
+        CollectionChanged(this, e);
+      }
     }
 
-    public event EventHandler<EnumerableEventArgs<T>> ItemsAdded;
-    protected void FireItemsAdded(IEnumerable<T> addedItems) {
-      OnItemsAdded(addedItems);
-    }
-    protected virtual void OnItemsAdded(IEnumerable<T> addedItems) {
-      if (ItemsAdded != null)
-        ItemsAdded(this, new EnumerableEventArgs<T>(addedItems));
+    protected virtual void FireCollectionCleared() {
+        NotifyCollectionChangedEventArgs e = new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset);
+        FireCollectionChanged( e);
     }
 
-    public event EventHandler<EnumerableEventArgs<T>> ItemsRemoved;
-    protected void FireItemsRemoved(IEnumerable<T> removedItems) {
-      OnItemsRemoved(removedItems);
+    protected virtual void FireItemsAdded(IEnumerable<T> addedItems, int index) {
+        NotifyCollectionChangedEventArgs e = new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Add, addedItems.ToList(), index);
+        FireCollectionChanged(e);
     }
-    protected virtual void OnItemsRemoved(IEnumerable<T> removedItems) {
-      if (ItemsRemoved != null)
-        ItemsRemoved(this, new EnumerableEventArgs<T>(removedItems));
+
+    protected virtual void FireItemsRemoved(IEnumerable<T> removedItems) {
+        NotifyCollectionChangedEventArgs e = new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Remove, removedItems.ToList());
+        FireCollectionChanged(e);
     }
     #endregion
@@ -63,11 +60,13 @@
     #region ICollection<T> Members
     public void Add(T item) {
+      int index = this.list.Count - 1;
       this.list.Add(item);
-      FireItemsAdded(new List<T> { item });
+      FireItemsAdded(new List<T> { item }, index);
     }
 
     public void AddRange(IEnumerable<T> items) {
+      int index = this.list.Count - 1;
       this.list.AddRange(items);
-      FireItemsAdded(items);
+      FireItemsAdded(items, index);
     }
 
@@ -125,4 +124,6 @@
 
     #endregion
+
+
   }
 }
Index: /trunk/sources/HeuristicLab.Common/3.2/ObservableList.cs
===================================================================
--- /trunk/sources/HeuristicLab.Common/3.2/ObservableList.cs	(revision 2458)
+++ /trunk/sources/HeuristicLab.Common/3.2/ObservableList.cs	(revision 2458)
@@ -0,0 +1,74 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Collections.Specialized;
+
+namespace HeuristicLab.Common {
+  public class ObservableList<T> : ObservableCollection<T>, IList<T> {
+
+    public ObservableList()
+      : base() {
+    }
+
+    #region IList<T> Members
+    public int IndexOf(T item) {
+      return list.IndexOf(item);
+    }
+
+    public void Insert(int index, T item) {
+      list.Insert(index, item);
+      FireItemsInserted(new List<T>() { item }, index);
+    }
+
+    public void RemoveAt(int index) {
+      T itemRemoved = list[index];
+      list.RemoveAt(index);
+      FireItemsRemoved(new List<T>() { itemRemoved });
+    }
+
+    public T this[int index] {
+      get {
+        return list[index];
+      }
+      set {
+        T oldItem = list[index];
+        list[index] = value;
+        FireItemsReplaced(value, oldItem, index);
+      }
+    }
+    #endregion
+
+    #region events
+    protected virtual void FireItemsInserted(IEnumerable<T> insertedItems, int index) {
+      NotifyCollectionChangedEventArgs e = new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Add, insertedItems.ToList(), index);
+      FireCollectionChanged(e);
+    }
+
+    protected virtual void FireItemsReplaced(T newItem, T oldItem, int index) {
+      NotifyCollectionChangedEventArgs e = new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Replace, newItem, oldItem);
+      FireCollectionChanged(e);
+    }
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewEditorAction.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewEditorAction.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewEditorAction.cs	(revision 2458)
@@ -6,15 +6,12 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewEditorAction : IAction{
-    #region IAction Members
-
-    public void Execute(IMainForm mainform) {
-      mainform.StatusStripText = "New Editor action called";
-      EditorView x = new EditorView();
-      x.Caption = "Editor View";
-      mainform.ShowView(x);
+  public static class NewEditorAction{
+    private static IView view;
+    public static void Execute(IMainForm mainform) {
+      if (view == null)
+        view = new EditorView();
+      view.Caption = "Editor View";
+      mainform.ShowView(view);
     }
-
-    #endregion
   }
 
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewFormAction.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewFormAction.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewFormAction.cs	(revision 2458)
@@ -6,15 +6,10 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewFormAction : IAction{
-    #region IAction Members
-
+  public class NewFormAction {
     public void Execute(IMainForm mainform) {
-      mainform.StatusStripText = "New form called";
-      FormView x = new FormView();
+      FormView1 x = new FormView1();
       x.Caption = "FormView";
       mainform.ShowView(x);
     }
-
-    #endregion
   }
 
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/OpenAction.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/OpenAction.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/OpenAction.cs	(revision 2458)
@@ -6,12 +6,8 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class OpenAction : IAction {
-    #region IAction Members
-
+  public class OpenAction  {
     public void Execute(IMainForm mainform) {
-      mainform.StatusStripText = "Open action called";
+      MessageBox.Show("Open action called");
     }
-
-    #endregion
   }
 }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/SaveAction.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/SaveAction.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/SaveAction.cs	(revision 2458)
@@ -6,10 +6,8 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class SaveAction : IAction{
-    #region IAction Members
+  public class SaveAction {
     public void Execute(IMainForm mainform) {
-      mainform.StatusStripText = "Save action called";
+      MessageBox.Show("Save action called");
     }
-    #endregion
   }
 }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewEditorToolStripButtonItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewEditorToolStripButtonItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewEditorToolStripButtonItem.cs	(revision 2458)
@@ -3,7 +3,8 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewEditorToolStripButtonItem : ToolStripButtonItemBase, ITestUserInterfaceItemProvider {
+  public class NewEditorToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 12; }
@@ -14,10 +15,14 @@
     }
 
-    public override string Structure {
-      get { return "New"; }
+    public override IEnumerable<string> Structure {
+      get { return new string []{"New"}; }
     }
 
-    public override void Execute(IMainForm mainform) {
-      new NewEditorAction().Execute(mainform);
+    public override System.Windows.Forms.ToolStripItemDisplayStyle ToolStripItemDisplayStyle {
+      get { return System.Windows.Forms.ToolStripItemDisplayStyle.ImageAndText; }
+    }
+
+    public override void Execute() {
+      NewEditorAction.Execute(MainFormManager.MainForm);
     }
   }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewFormToolStripButtonItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewFormToolStripButtonItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewFormToolStripButtonItem.cs	(revision 2458)
@@ -3,7 +3,8 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewFormToolStripButtonItem : ToolStripButtonItemBase, ITestUserInterfaceItemProvider {
+  public class NewFormToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 11; }
@@ -14,10 +15,14 @@
     }
 
-    public override string Structure {
-      get { return "New"; }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "New" }; }
     }
 
-    public override void Execute(IMainForm mainform) {
-      new NewFormAction().Execute(mainform);
+    public override System.Windows.Forms.ToolStripItemDisplayStyle ToolStripItemDisplayStyle {
+      get { return System.Windows.Forms.ToolStripItemDisplayStyle.ImageAndText; }
+    }
+
+    public override void Execute() {
+      new NewFormAction().Execute(MainFormManager.MainForm);
     }
   }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewToolStripButtonItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewToolStripButtonItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewToolStripButtonItem.cs	(revision 2458)
@@ -3,7 +3,8 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewToolStripButtonItem : ToolStripButtonItemBase, ITestUserInterfaceItemProvider {
+  public class NewToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 10; }
@@ -22,5 +23,5 @@
     }
 
-    public override void Execute(IMainForm mainform) {
+    public override void Execute() {
     }
   }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs	(revision 2458)
@@ -3,7 +3,8 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
-  public class OpenToolStripButtonItem : ToolStripButtonItemBase, ITestUserInterfaceItemProvider {
+  public class OpenToolStripButtonItem : ToolBarItemBase, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 20; }
@@ -18,6 +19,6 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      new OpenAction().Execute(mainform);
+    public override void Execute() {
+      new OpenAction().Execute(MainFormManager.MainForm);
     }
   }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SaveToolStripButtonItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SaveToolStripButtonItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SaveToolStripButtonItem.cs	(revision 2458)
@@ -3,7 +3,8 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
-  public class SaveToolStripButtonItem : ToolStripButtonItemBase, ITestUserInterfaceItemProvider {
+  public class SaveToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 30; }
@@ -18,14 +19,14 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      new SaveAction().Execute(mainform);
+    public override void Execute() {
+      new SaveAction().Execute(MainFormManager.MainForm);
     }
 
     public override void ActiveViewChanged(object sender, EventArgs e) {
-      IMainForm mainform = (IMainForm)sender;
+      IMainForm mainform = MainFormManager.MainForm;
       if (mainform.ActiveView == null)
         this.ToolStripItem.Enabled = false;
       else
-        this.ToolStripItem.Enabled = !(mainform.ActiveView is FormView);
+        this.ToolStripItem.Enabled = !(mainform.ActiveView is FormView1);
     }
 
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/EditorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/EditorView.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/EditorView.cs	(revision 2458)
@@ -7,20 +7,33 @@
 using System.Text;
 using System.Windows.Forms;
+using HeuristicLab.MainForm.WindowsForms;
+using System.Collections;
 
 namespace HeuristicLab.MainForm.Test {
-  public partial class EditorView : ViewBase {
+  [DefaultViewAttribute]
+  public partial class EditorView : ViewBase<ArrayList> {
     public EditorView() {
       InitializeComponent();
     }
 
-    public EditorView(IMainForm mainform)
-      : base(mainform) {
+    private void ChangeStateButton_Click(object sender, EventArgs e) {
+      IEnumerable<Type> views = MainFormManager.GetViewTypes(typeof(ArrayList));
+      views.ToString();
+      IEnumerable<Type> views1 = MainFormManager.GetViewTypes(typeof(IList));
+      views1.ToString();
+      //IEnumerable<Type> views2 = MainFormManager.GetViewTypes(typeof(object));
+      //views2.ToString();
+      Type def2 = MainFormManager.GetDefaultViewType(typeof(IList));
+      def2.ToString();
+      Type def1 = MainFormManager.GetDefaultViewType(typeof(ArrayList));
+      def1.ToString();
+      //Type def3 = MainFormManager.GetDefaultViewType(typeof(object));
+      //def3.ToString();
+
+      MainFormManager.MainForm.HideView(this);
+      this.OnChanged();
     }
 
-    private void ChangeStateButton_Click(object sender, EventArgs e) {
-      this.OnStateChanged();
-    }
-
-    public override void FormClosing(object sender, FormClosingEventArgs e) {
+    public override void OnClosing(object sender, CancelEventArgs e) {
       if (DialogResult.Yes != MessageBox.Show(
              "Recent changes have not been saved. Close the editor anyway?", "Close editor?",
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView.Designer.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView.Designer.cs	(revision 2458)
@@ -1,4 +1,4 @@
 ﻿namespace HeuristicLab.MainForm.Test {
-  partial class FormView {
+  partial class FormView1 {
     /// <summary> 
     /// Required designer variable.
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView.cs	(revision 2458)
@@ -7,14 +7,13 @@
 using System.Text;
 using System.Windows.Forms;
+using HeuristicLab.MainForm.WindowsForms;
+using System.Collections;
 
 namespace HeuristicLab.MainForm.Test {
-  public partial class FormView : ViewBase {
+  [DefaultViewAttribute]
+  public partial class FormView1 : ViewBase<ICollection> {
     private int[] array;
-    public FormView() {
+    public FormView1() {
       InitializeComponent();
-    }
-
-    public FormView(IMainForm mainform)
-      : base(mainform) {
     }
   }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView2.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView2.Designer.cs	(revision 2458)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView2.Designer.cs	(revision 2458)
@@ -0,0 +1,55 @@
+﻿namespace HeuristicLab.MainForm.Test {
+  partial class FormView2 {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.label1 = new System.Windows.Forms.Label();
+      this.SuspendLayout();
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.ForeColor = System.Drawing.Color.Coral;
+      this.label1.Location = new System.Drawing.Point(112, 110);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(61, 13);
+      this.label1.TabIndex = 0;
+      this.label1.Text = "Form VIEW";
+      // 
+      // FormView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.label1);
+      this.Name = "FormView";
+      this.Size = new System.Drawing.Size(385, 267);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label label1;
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView2.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView2.cs	(revision 2458)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/FormView2.cs	(revision 2458)
@@ -0,0 +1,18 @@
+﻿using System;
+using System.Collections;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.MainForm.Test {
+  public partial class FormView2 : ViewBase<IEnumerable> {
+    private int[] array;
+    public FormView2() {
+      InitializeComponent();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLab.MainForm.Test-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLab.MainForm.Test-3.2.csproj	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLab.MainForm.Test-3.2.csproj	(revision 2458)
@@ -87,4 +87,10 @@
     <Compile Include="ButtonItems\SaveToolStripButtonItem.cs" />
     <Compile Include="ButtonItems\OpenToolStripButtonItem.cs" />
+    <Compile Include="FormView2.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="FormView2.Designer.cs">
+      <DependentUpon>FormView2.cs</DependentUpon>
+    </Compile>
     <Compile Include="HeuristicLabSingleDocumentMainFormTestApplication.cs" />
     <Compile Include="HeuristicLabMultipleDocumentMainFormTestApplication.cs" />
@@ -104,6 +110,4 @@
     <Compile Include="MenuItems\NewFormToolStripMenuItem.cs" />
     <Compile Include="MenuItems\NewEditorToolStripMenuItem.cs" />
-    <Compile Include="MenuItems\FileToolStripMenuItem.cs" />
-    <Compile Include="MenuItems\NewToolStripMenuItem.cs" />
     <Compile Include="Actions\NewFormAction.cs" />
     <Compile Include="Actions\OpenAction.cs" />
@@ -125,4 +129,8 @@
       <Name>HeuristicLab.Common.Resources-3.2</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.2\HeuristicLab.MainForm.WindowsForms.csproj">
+      <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
+      <Name>HeuristicLab.MainForm.WindowsForms</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.MainForm\3.2\HeuristicLab.MainForm-3.2.csproj">
       <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
@@ -138,4 +146,7 @@
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="FormView2.resx">
+      <DependentUpon>FormView2.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="EditorView.resx">
       <DependentUpon>EditorView.cs</DependentUpon>
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabDockingMainFormTestApplication.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabDockingMainFormTestApplication.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabDockingMainFormTestApplication.cs	(revision 2458)
@@ -25,5 +25,5 @@
 using System.Windows.Forms;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabMainFormTestPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabMainFormTestPlugin.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabMainFormTestPlugin.cs	(revision 2458)
@@ -25,8 +25,8 @@
 using HeuristicLab.PluginInfrastructure;
 
-namespace HeuristicLab.Modeling.Database {
+namespace HeuristicLab.MainForm.Test {
   [ClassInfo(Name = "HeuristicLab.MainForm.Test-3.2")]
-  [PluginFile(Filename = "HeuristicLab.MainForm.Test-3.2.dll", Filetype = PluginFileType.Assembly)]  
-  [Dependency(Dependency = "HeuristicLab.MainForm-3.2")]
+  [PluginFile(Filename = "HeuristicLab.MainForm.Test-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.MainForm.WindowsForms-3.2")]
   [Dependency(Dependency = "HeuristicLab.Common.Resources-3.2")]
   public class HeuristicLabMainFormTestPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabMultipleDocumentMainFormTestApplication.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabMultipleDocumentMainFormTestApplication.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabMultipleDocumentMainFormTestApplication.cs	(revision 2458)
@@ -25,5 +25,5 @@
 using System.Windows.Forms;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs	(revision 2458)
@@ -25,5 +25,5 @@
 using System.Windows.Forms;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/ExitToolStripMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/ExitToolStripMenuItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/ExitToolStripMenuItem.cs	(revision 2458)
@@ -5,15 +5,15 @@
 using System.Windows.Forms;
 
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.MainForm.Test {
-  public class CloseToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class CloseToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Exit"; }
     }
 
-    public override string Structure {
-      get { return "File"; }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "File" }; }
     }
 
@@ -22,6 +22,6 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      mainform.Close();
+    public override void Execute() {
+      MainFormManager.MainForm.Close();
     }
   }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewEditorToolStripMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewEditorToolStripMenuItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewEditorToolStripMenuItem.cs	(revision 2458)
@@ -5,15 +5,15 @@
 using System.Windows.Forms;
 
-using HeuristicLab.MainForm;
 using HeuristicLab.Common.Resources;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewEditorToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class NewEditorToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Editor"; }
     }
 
-    public override string Structure {
-      get { return "File/New"; }
+    public override IEnumerable<string> Structure {
+      get { return "File/New".Split('/'); }
     }
 
@@ -22,6 +22,6 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      new NewEditorAction().Execute(mainform);
+    public override void Execute() {
+      NewEditorAction.Execute(MainFormManager.MainForm);
     }
   }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewFormToolStripMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewFormToolStripMenuItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewFormToolStripMenuItem.cs	(revision 2458)
@@ -5,23 +5,24 @@
 using System.Windows.Forms;
 
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewFormToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class NewFormToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Form"; }
     }
 
-    public override string Structure {
-      get { return "File/New"; }
+    public override IEnumerable<string> Structure {
+      get { return "File/New".Split('/'); }
     }
 
     public override int Position {
       get { return 1110; }
+    
     }
 
-    public override void Execute(IMainForm mainform) {
-      new NewFormAction().Execute(mainform);
+    public override void Execute() {
+      new NewFormAction().Execute(MainFormManager.MainForm);
     }
   }
Index: /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/OpenToolStripMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/OpenToolStripMenuItem.cs	(revision 2457)
+++ /trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/OpenToolStripMenuItem.cs	(revision 2458)
@@ -4,15 +4,15 @@
 using System.Text;
 using System.Windows.Forms;
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.MainForm.Test {
-  public class OpenToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class OpenToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Open"; }
-    }   
+    }
 
-    public override string Structure {
-      get { return "File"; }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "File" }; }
     }
 
@@ -29,6 +29,6 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      new OpenAction().Execute(mainform);
+    public override void Execute() {
+      new OpenAction().Execute(MainFormManager.MainForm);
     }
   }
